{|===============================================================================|
 |                                                                               |
 |                              H E R E A   S O F T                              |
 |                           Unit : OleOperations.pas                           |
 |                        Ecrit par : Alexandre le Grand                         |
 |                  e-mail : alexandre.le.grand@libertysurf.fr                   |
 |                   Copyright : (c)dimanche 12 novembre 2000                    |
 |                                                                               |
 |                                Version : 0.0.0                                |
 |                                                                               |
 |===============================================================================|}

Unit
  OleOperations;

Interface

Uses
  Windows, SysUtils, Classes, Graphics, ActiveX, comctrls, RichOle, RichEdit,
  Forms, ClipBrd, extdlgs, ComObj, ShellApi, ShlObj, jpeg; //GIFImage

//Classe pour l'enrichissement du contrle RichEdit------------------------------
Type
  TRichEditOleCallback = Class(TInterfacedObject, IRichEditOleCallback)
  Public
    Function QueryInterface(Const iid : TGUID;Out Obj) : HResult;Stdcall;
    Function _AddRef : Longint;Stdcall;
    Function _Release : Longint;Stdcall;
    Function GetNewStorage(Out stg : IStorage) : HResult;Stdcall;
    Function GetClipboardData(Const chrg : TCharRange;reco : DWORD;
      Out dataobj : IDataObject) : HResult;Stdcall;
    Function GetContextMenu(seltype : Word;Const oleobj : IOleObject;
      Const chrg : TCharRange;Out Menu : HMENU) : HResult;Stdcall;
    Function GetInPlaceContext(Out Frame : IOleInPlaceFrame;
      Out Doc : IOleInPlaceUIWindow;
      lpFrameInfo : POleInPlaceFrameInfo) : HResult;Stdcall;
    Function ShowContainerUI(fShow : BOOL) : HResult;Stdcall;
    Function QueryInsertObject(Const clsid : TCLSID;Const stg : IStorage;
      cp : Longint) : HResult;Stdcall;
    Function DeleteObject(Const oleobj : IOleObject) : HResult;Stdcall;
    Function QueryAcceptData(Const dataobj : IDataObject;Var cfFormat : TClipFormat;
      reco : DWORD;fReally : BOOL;hMetaPict : HGLOBAL) : HResult;Stdcall;
    Function ContextSensitiveHelp(fEnterMode : BOOL) : HResult;Stdcall;
    Function GetDragDropEffect(fDrag : BOOL;grfKeyState : DWORD;
      Var dwEffect : DWORD) : HResult;Stdcall;
  End;

Var
  MyCallback : TRichEditOleCallback;

Const
  CLSID_NULL : TCLSID = '{00000000-0000-0000-0000-000000000000}';

  //Utilitaires pour la manipulation des Objets OLE------------------------------
Procedure CreateIStorage(Out Fstorage : Istorage);
Function GetRichOleInterface(ARichEdit : TRichEdit;Out RichOleInterface : IRichEditOle;Out OleClientSite : IOleclientSite) : boolean;
Procedure REOleSetCallback(RichEdit : TRichEdit;OleInterface : IRichEditOleCallback);
Procedure ReleaseObject(Var Obj);
Function SetFormatEtc(Cf : TClipFormat;med : Longint;td : PDVTargetDevice = Nil;
  Asp : Longint = DVASPECT_CONTENT;li : Longint = -1) : TFormatEtc;
Function OleSwitchDisplayAspect(OleObject : IOleObject;Var CurrentAspect : DWORD;
  NewAspect : DWORD;METAFILEPICT : THandle;DeleteOldAspect, SetUpViewAdvise : boolean;
  AdviseSink : IAdviseSink;Var MustUpdate : boolean) : HRESULT;
Function GetOleClassFile(Const Name : String) : TCLSID;
Function OleCopyPasString(Const Source : String;Malloc : IMalloc = Nil) : POleStr;
Function SetStgMedium(Stg, Handle : longint;Release : pointer = Nil) : TStgMedium;
Procedure OleFreeString(Str : POleStr;Malloc : IMalloc = Nil);
Function OleMalloc(Size : Longword;Malloc : IMalloc = Nil) : pointer;
Procedure OleFree(Mem : pointer;Malloc : IMalloc = Nil);
Procedure ChangeOleIcon(REdit : TRichEdit;HIcon : Hwnd;LabelIcon : String);

//Fonctions d'insertion---------------------------------------------------------
Function InsertFromImage(REdit : TRichEdit;FilePath : String) : Bool;
Procedure InsertFromImages(REdit : TRichEdit;Files : TStrings);
Procedure InsertFromFile(REdit : TRichEdit;FilePath : String;Linked : bool;AsIcon : Bool);
Procedure InsertFromFiles(REdit : TRichEdit;Files : TStrings;Linked : bool;AsIcon : Bool);


Implementation

//Implmentation de la classe TRichEditOleCllback--------------------------------

Function TRichEditOleCallback.QueryInterface(Const iid : TGUID;Out Obj) : HResult;
Begin
  If GetInterface(iid, Obj) Then
    Result := S_OK
  Else
    Result := E_NOINTERFACE;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback._AddRef : LongInt;
Begin
  Inc(FRefCount);
  Result := FRefCount;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback._Release : LongInt;
Begin
  Dec(FRefCount);
  Result := FRefCount;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.GetNewStorage(
  Out stg : IStorage) : HResult;
Begin
  Try
    CreateIStorage(stg);
    Result := S_OK;
  Except
    Result := E_OUTOFMEMORY;
  End;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.GetClipboardData(Const chrg : TCharRange;reco : DWORD;
  Out dataobj : IDataObject) : HResult;
Begin
  Result := E_NOTIMPL;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.GetContextMenu(seltype : Word;
  Const oleobj : IOleObject;Const chrg : TCharRange;
  Out Menu : HMENU) : HResult;
Begin
  Result := E_NOTIMPL;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.GetInPlaceContext(Out Frame : IOleInPlaceFrame;Out Doc : IOleInPlaceUIWindow;lpFrameInfo : POleInPlaceFrameInfo) : HResult;
Begin
  Result := S_OK;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.QueryInsertObject(Const clsid : TCLSID;Const stg : IStorage;
  cp : Longint) : HResult;
Begin
  Result := NOERROR;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.DeleteObject(Const oleobj : IOleObject) : HResult;
Begin
  If Assigned(oleobj) Then oleobj.Close(OLECLOSE_NOSAVE);
  Result := NOERROR;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.QueryAcceptData(Const dataobj : IDataObject;
  Var cfFormat : TClipFormat;reco : DWORD;fReally : BOOL;
  hMetaPict : HGLOBAL) : HResult;
Begin
  Result := S_OK;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.ContextSensitiveHelp(fEnterMode : BOOL) : HResult;
Begin
  Result := NOERROR;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.GetDragDropEffect(fDrag : BOOL;grfKeyState : DWORD;
  Var dwEffect : DWORD) : HResult;
Begin
  Result := E_NOTIMPL;
End;

//------------------------------------------------------------------------------

Function TRichEditOleCallback.ShowContainerUI(fShow : BOOL) : HResult;
Begin
  Result := S_OK;
End;

//Implmentation des utilitaires OLE--------------------------------------------

Procedure CreateIStorage(Out Fstorage : Istorage);
// Cre un IStorage
Var
  FlockBytes : IlockBytes;
Begin
  OleCheck(CreateILockBytesOnHGlobal(0, True, FLockBytes));
  OleCheck(StgCreateDocfileOnILockBytes(FLockBytes, STGM_SHARE_EXCLUSIVE Or STGM_CREATE Or STGM_READWRITE, 0, FStorage))
End;

//------------------------------------------------------------------------------

Function GetRichOleInterface(ARichEdit : TRichEdit;Out RichOleInterface : IRichEditOle;Out OleClientSite : IOleclientSite) : boolean;
// Affecte une OleInterface  RichEdit et rcupre IRichOleInterface et IOleClientSite
Var
  AppName : String;
Begin
  Result := False;
  If boolean(SendMessage(ARichEdit.Handle, EM_GETOLEINTERFACE, 0, longint(@RichOleInterface))) Then
  Begin
    Try
      AppName := Application.Title;
      If Trim(AppName) = '' Then AppName := ExtractFileName(Application.ExeName);
      RichOleInterface.SetHostNames(PChar(AppName), PChar(AppName));
      RichOleInterface.GetClientSite(OleclientSite);
      Result := True;
    Except
      Result := False;
    End;
  End;
End;

//------------------------------------------------------------------------------

Procedure REOleSetCallback(RichEdit : TRichEdit;OleInterface : IRichEditOleCallback);
// Affecte une RichOleCallback  un RichEdit
Begin
  SendMessage(RichEdit.Handle, EM_SETOLECALLBACK, 0, LPARAM(Oleinterface));
End;

//------------------------------------------------------------------------------

Procedure ReleaseObject(Var Obj);
// Release
Begin
  If IUnknown(Obj) <> Nil Then
  Begin
    IUnknown(Obj)._Release;
    IUnknown(Obj) := Nil;
  End;
End;

//------------------------------------------------------------------------------

Function SetFormatEtc(Cf : TClipFormat;med : Longint;td : PDVTargetDevice = Nil;
  Asp : Longint = DVASPECT_CONTENT;li : Longint = -1) : TFormatEtc;
// Remplit une structure de type TFormatEtc
Begin
  With Result Do
  Begin
    cfFormat := cf;
    dwAspect := asp;
    ptd := td;
    tymed := med;
    lindex := li
  End
End;

//------------------------------------------------------------------------------

Function OleSwitchDisplayAspect(OleObject : IOleObject;Var CurrentAspect : DWORD;
  NewAspect : DWORD;METAFILEPICT : THandle;DeleteOldAspect, SetUpViewAdvise : boolean;
  AdviseSink : IAdviseSink;Var MustUpdate : boolean) : HRESULT;
// Change l'aspect de l'objet insr
Var
  OleCache : IOleCache;
  ViewObject : IViewObject;
  EnumStatData : IEnumStatData;
  StatData : TStatData;
  FormatEtc : TFormatEtc;
  Medium : TStgMedium;
  Advf,
    NewConnection,
    OldAspect : longint;
  Error : HRESULT;
Begin
  OleCache := Nil;
  ViewObject := Nil;
  EnumStatData := Nil;
  OldAspect := CurrentAspect;
  MustUpdate := False;
  If Failed(OleObject.QueryInterface(IOleCache, OleCache)) Then
  Begin
    // Si IOleCache n'est pas accessible alors Exit
    Result := E_INVALIDARG;
    Exit
  End;
  // Affecte un nouveau cache avec le nouvel aspect
  FormatEtc := SetFormatEtc(0, TYMED_NULL, Nil, NewAspect);

  If (NewAspect = dvaspect_Icon) And (METAFILEPICT <> 0) Then
    Advf := advf_nodata
  Else
    Advf := ADVF_PRIMEFIRST;
  Result := OleCache.Cache(FormatEtc, Advf, NewConnection);
  If Failed(Result) Then
    Exit;
  CurrentAspect := NewAspect;

  If (NewAspect = dvaspect_Icon) And (METAFILEPICT <> 0) Then
  Begin
    FormatEtc := SetFormatEtc(CF_METAFILEPICT, TYMED_MFPICT, Nil, dvaspect_Icon);
    Medium := SetStgMedium(TYMED_MFPICT, METAFILEPICT);
    OleCache.SetData(FormatEtc, Medium, False)
  End
  Else
    MustUpdate := True;
  If SetUpViewAdvise And Assigned(AdviseSink) Then
    If Succeeded(OleObject.QueryInterface(IViewObject, ViewObject)) Then
    Begin
      ViewObject.SetAdvise(NewAspect, 0, AdviseSink);
      ViewObject := Nil
    End;
  // Efface l'ancien cache
  If DeleteOldAspect Then
  Begin
    Error := OleCache.EnumCache(EnumStatData);
    While Error = S_OK Do
    Begin
      Error := EnumStatData.Next(1, StatData, Nil);
      If Error = S_OK Then
        If StatData.FormatEtc.dwAspect = OldAspect Then
          OleCache.Uncache(StatData.dwConnection)
    End
  End;
  Result := S_OK
End;


//------------------------------------------------------------------------------

Function GetOleClassFile(Const Name : String) : TCLSID;
// Rcupre si possible le CLSID d'un fichier
Var
  Buffer : POleStr;
Begin
  Result := CLSID_NULL;
  Buffer := OleCopyPasString(Name);
  Try
    OleCheck(GetClassFile(Buffer, Result))
  Finally
    If Assigned(Buffer) Then
      OleFreeString(Buffer)
  End
End;

//------------------------------------------------------------------------------

Function OleCopyPasString(Const Source : String;Malloc : IMalloc = Nil) : POleStr;
// Copie une chane dans une variable de type POleStr (PWideChar)
//(heu! oui c'est vrai il y avait StringToOleStr dj toute faite :))
Var
  Size : Integer;
Begin
  Size := Length(Source);
  If Size = 0 Then
    Result := Nil
  Else
  Begin
    Inc(Size);
    Result := OleMalloc(Size * SizeOf(WideChar), Malloc);
    If Not Assigned(Result) Then
      OutOfMemoryError;
    StringToWideChar(Source, Result, Size)
  End
End;

//------------------------------------------------------------------------------

Function SetStgMedium(Stg, Handle : longint;Release : pointer = Nil) : TStgMedium;
// Remplit une structure de type TStgMedium
Begin
  Result.tymed := Stg;
  Result.hGlobal := Handle;
  Result.unkForRelease := Release
End;

//------------------------------------------------------------------------------

Procedure OleFreeString(Str : POleStr;Malloc : IMalloc = Nil);
Begin
  OleFree(Str, Malloc)
End;

//------------------------------------------------------------------------------

Function OleMalloc(Size : Longword;Malloc : IMalloc = Nil) : pointer;
// Alloue et retourne un pointeur d'un block mmoire
Begin
  If Not Assigned(Malloc) Then
    Result := CoTaskMemAlloc(Size)
  Else
    Result := Malloc.Alloc(Size)
End;

//------------------------------------------------------------------------------

Procedure OleFree(Mem : pointer;Malloc : IMalloc = Nil);
// Libre un bloc mmoire
Var
  Ok : Integer;
Begin
  If Not Assigned(Malloc) Then
  Begin
    Ok := CoGetMalloc(MEMCTX_TASK, Malloc);
    Assert(Ok = NOERROR, 'CoGetMalloc  chou');
  End;
  Ok := Malloc.DidAlloc(Mem);
  Assert(Ok = S_FALSE, 'Impossible de librer le block mmoire');
  Malloc.Free(Mem)
End;

//------------------------------------------------------------------------------

Procedure ChangeOleIcon(REdit : TRichEdit;HIcon : Hwnd;LabelIcon : String);
// Change l'aspect icne de l'objet slectionn
Var
  Update : Boolean;
  SelectionType : Integer;
  RichEditOle : IRichEditOle;
  OleClientSite : IOleClientSite;
  REObject : TReObject;
Begin
  Update := True;
  FillChar(ReObject, SizeOf(ReObject), 0);
  ReObject.cbStruct := SizeOf(ReObject);
  SelectionType := SendMessage(Redit.Handle, EM_SELECTIONTYPE, 0, 0);
  If selectiontype = SEL_OBJECT Then
    GetRichOleInterface(REdit, RichEditOle, OleClientSite);
  OleCheck(RichEditOle.GetObject(Longint(REO_IOB_SELECTION), ReObject, REO_GETOBJ_POLEOBJ Or REO_GETOBJ_POLESITE));
  HIcon := OleMetafilePictFromIconAndLabel(Hicon, OleCopyPasString(LabelIcon), '', 0);
  OleSwitchDisplayAspect(REObject.oleobj, REObject.dvaspect, REObject.dvaspect, Hicon, False, False, Nil, Update);
  OleCheck(REobject.oleobj.Update);
End;

//Implmentation des fonctions d'insertion--------------------------------------

Function InsertFromImage(REdit : TRichEdit;FilePath : String) : bool;
// Insre une image
Var
  Pict : TPicture;
Begin
  Pict := TPicture.Create;
  Try
    Result := False;
    Pict.LoadFromFile(FilePath);
    Clipboard.Assign(Pict);
    REdit.PasteFromClipboard;
    Result := True;
  Finally
    Pict.Free;
  End;
End;

//------------------------------------------------------------------------------

Procedure InsertFromImages(REdit : TRichEdit;Files : TStrings);
// Insre des images
Var
  Pict : TPicture;
  I : Integer;
Begin
  Pict := TPicture.Create;
  Try
    For I := 0 To Files.Count - 1 Do
    Begin
      Pict.LoadFromFile(Files[I]);
      Clipboard.Assign(Pict);
      REdit.PasteFromClipboard;
    End;
  Finally
    Pict.Free;
  End;
End;

//------------------------------------------------------------------------------

Procedure InsertFromFiles(REdit : TRichEdit;Files : TStrings;Linked : bool;AsIcon : Bool);
// Insre plusieurs fichiers
Var
  I : Integer;
  FilePath : String;
  Ind : word;
  HIcon : hwnd;
  Update : boolean;
  OleClientSite : IOleClientSite;
  Storage : IStorage;
  OleObject : IOleObject;
  ReObject : TReObject;
  RichEditOle : IrichEditOle;
Begin
  Ind := 1;
  Update := True;
  FillChar(ReObject, SizeOf(TReObject), 0);
  For I := 0 To Files.Count - 1 Do
  Begin
    FilePath := Files[I];
    If GetRichOleInterface(REdit, RichEDitOle, OleClientSite) Then // Rcupre IRichEDitOle et IOleClientSite
    Begin
      Storage := Nil;
      Try
        CreateIStorage(Storage); // Cre un espace d'accueil
        If Linked Then
          OleCheck(OleCreateLinkToFile(OleCopyPasString(FilePath), IOleObject, OLERENDER_DRAW, Nil, OleClientSite, Storage, OleObject))
        Else
          OleCheck(OleCreateLinkToFile(OleCopyPasString(FilePath), IOleObject, OLERENDER_DRAW, Nil, OleClientSite, Storage, OleObject));
        With ReObject Do
        Begin // Remplit la structure REObject
          cbStruct := SizeOf(TReObject);
          cp := Integer(REO_CP_SELECTION);
          OleObject.GetUserClassId(CLSID);
          oleobj := OleObject;
          stg := Storage;
          olesite := OleClientSite;
          If Asicon Then
            DvAspect := DVASPECT_ICON
          Else
            DvAspect := DVASPECT_CONTENT;
          dwFlags := REO_RESIZABLE Or REO_DYNAMICSIZE;
        End;
        // Essaye de rcuprer le CLSID du fichier
        If IsEqualCLSID(REObject.CLSID, CLSID_NULL) Then
          REObject.CLSID := GetOleClassFile(FilePath);
        // Fabrication de l'icne
        HIcon := ShellAPI.ExtractAssociatedIcon(Application.Handle, PChar(FilePath), Ind);
        HIcon := OleMetafilePictFromIconAndLabel(Hicon, OleCopyPasString(ExtractFileName(FilePath)), '', 0);
        OleSwitchDisplayAspect(OleObject, REObject.dvaspect, REObject.dvaspect, Hicon, False, False, Nil, Update);
        // Insertion
        OleCheck(RichEditOle.InsertObject(ReObject));
        SendMessage(REdit.Handle, EM_SCROLLCARET, 0, 0);
        OleCheck(OleObject.Update);
      Finally
        // OleObject:=nil; ?
        OleClientSite := Nil;
        Storage := Nil;
      End;
    End;
  End;
End;

//------------------------------------------------------------------------------

Procedure InsertFromFile(REdit : TRichEdit;FilePath : String;Linked : bool;AsIcon : Bool);
// Insre un fichier
Var
  Ind : word;
  HIcon : hwnd;
  Update : boolean;
  OleClientSite : IOleClientSite;
  Storage : IStorage;
  OleObject : IOleObject;
  ReObject : TReObject;
  RichEditOle : IrichEditOle;
Begin
  Ind := 1;
  Update := True;
  FillChar(ReObject, SizeOf(TReObject), 0);
  If GetRichOleInterface(REdit, RichEDitOle, OleClientSite) Then // Rcupre IRichEDitOle et IOleClientSite
  Begin
    Storage := Nil;
    Try
      CreateIStorage(Storage); // Cre un espace d'accueil
      If Linked Then
        OleCheck(OleCreateLinkToFile(OleCopyPasString(FilePath), IOleObject, OLERENDER_DRAW, Nil, OleClientSite, Storage, OleObject))
      Else
        OleCheck(OleCreateLinkToFile(OleCopyPasString(FilePath), IOleObject, OLERENDER_DRAW, Nil, OleClientSite, Storage, OleObject));
      With ReObject Do
      Begin // Remplit la structure REObject
        cbStruct := SizeOf(TReObject);
        cp := Integer(REO_CP_SELECTION);
        OleObject.GetUserClassId(CLSID);
        oleobj := OleObject;
        stg := Storage;
        olesite := OleClientSite;
        If Asicon Then
          DvAspect := DVASPECT_ICON
        Else
          DvAspect := DVASPECT_CONTENT;
        dwFlags := REO_RESIZABLE Or REO_DYNAMICSIZE;
      End;
      // Essaye de rcuprer le CLSID du fichier si lors de la cration
      // de l'objet celui-ci vallait CLSID_NULL
      If IsEqualCLSID(REObject.CLSID, CLSID_NULL) Then
        REObject.CLSID := GetOleClassFile(FilePath);
      // Fabrication de l'icne
      HIcon := ShellAPI.ExtractAssociatedIcon(Application.Handle, PChar(FilePath), Ind);
      HIcon := OleMetafilePictFromIconAndLabel(Hicon, OleCopyPasString(ExtractFileName(FilePath)), '', 0);
      OleSwitchDisplayAspect(OleObject, REObject.dvaspect, REObject.dvaspect, Hicon, False, False, Nil, Update);
      // Insertion
      OleCheck(RichEditOle.InsertObject(ReObject));
      SendMessage(REdit.Handle, EM_SCROLLCARET, 0, 0);
      OleCheck(OleObject.Update);
    Finally
      // OleObject:=nil; ?
      OleClientSite := Nil;
      Storage := Nil;
    End;
  End;
End;
End.

