{===============================================================================|
 |                                                                              |
 |                             H E R E A   S O F T                              |
 |                             Unit : RichOle.pas                              |
 |                        Ecrit par : Alexandre le Grand                        |
 |                  e-mail : alexandre.le.grand@libertysurf.fr                  |
 |                      Copyright : (c)jeudi 31 aot 2000                       |
 |                                                                              |
 |                               Version : 1.0.0                                |
 |                                                                              |
 |==============================================================================|}

Unit
  RichOle;

Interface

Uses
  Windows, ActiveX, Richedit;

Type
  TREObject = Packed Record
    cbStruct : DWORD; // Taille de la structure
    cp : longint; // Position des caractres
    clsid : TCLSID; // ClassID de l'objet
    oleobj : IOleObject; // Interface OLE de l'objet
    stg : IStorage; // Interface Istorage associe
    olesite : IOLEClientSite; // Interface IOLEClientSite associe
    SIZEL : TSize; // Taille de l'objet
    dvaspect : DWORD; // Aspect
    dwFlags : DWORD; // Flags de l'objet
    dwUser : DWORD // Dword
  End;

  //Constantes--------------------------------------------------------------------
Const
  REO_GETOBJ_NO_INTERFACES = $00000000;
  REO_GETOBJ_POLEOBJ = $00000001;
  REO_GETOBJ_PSTG = $00000002;
  REO_GETOBJ_POLESITE = $00000004;
  REO_GETOBJ_ALL_INTERFACES = $00000007;

  REO_CP_SELECTION = $FFFFFFFF; // -1
  REO_IOB_SELECTION = $FFFFFFFF; // -1
  REO_IOB_USE_CP = $FFFFFFFE; // -2

  REO_NULL = $00000000; // Pas de flags
  REO_READWRITEMASK = $0000003F; // Mask out RO bits
  REO_DONTNEEDPALETTE = $00000020; // L'objet n'a pas besoin de palette
  REO_BLANK = $00000010; // L'objet est vide
  REO_DYNAMICSIZE = $00000008; // Object defines size always
  REO_INVERTEDSELECT = $00000004; // L'objet est dessin en couleur inverse lors de la slection
  REO_BELOWBASELINE = $00000002; // L'objet  un contour
  REO_RESIZABLE = $00000001; // L'objet peut tre redimensionn
  REO_LINK = $80000000; // L'objet est li (RO)
  REO_STATIC = $40000000; // L'objet est statique (RO)
  REO_SELECTED = $08000000; // Objet slectionn (RO)
  REO_OPEN = $04000000; // L'objet est ouvert dans son serveur (RO)
  REO_INPLACEACTIVE = $02000000; // Object in place active (RO)
  REO_HILITED = $01000000; // Object is to be highlighted (RO)
  REO_LINKAVAILABLE = $00800000; // Link believed available (RO)
  REO_GETMETAFILE = $00400000; // Object requires metafile (RO)

  RECO_PASTE = $00000000;
  RECO_DROP = $00000001;
  RECO_COPY = $00000002;
  RECO_CUT = $00000003;
  RECO_DRAG = $00000004;

  //IRichEditOle------------------------------------------------------------------
  //Interface utilise par RichEdit pour manipuler des objets OLE.
Type
  IRichEditOle = Interface(IUnknown)
    ['{00020d00-0000-0000-c000-000000000046}']
    Function GetClientSite(Out clientSite : IOleClientSite) : HResult;Stdcall;
    Function GetObjectCount : HResult;Stdcall;
    Function GetLinkCount : HResult;Stdcall;
    Function GetObject(iob : Longint;Out reobject : TReObject;
      dwFlags : DWORD) : HResult;Stdcall;
    Function InsertObject(Var reobject : TReObject) : HResult;Stdcall;
    Function ConvertObject(iob : Longint;rclsidNew : TIID;
      lpstrUserTypeNew : LPCSTR) : HResult;Stdcall;
    Function ActivateAs(rclsid : TIID;rclsidAs : TIID) : HResult;Stdcall;
    Function SetHostNames(lpstrContainerApp : LPCSTR;
      lpstrContainerObj : LPCSTR) : HResult;Stdcall;
    Function SetLinkAvailable(iob : Longint;fAvailable : BOOL) : HResult;Stdcall;
    Function SetDvaspect(iob : Longint;dvaspect : DWORD) : HResult;Stdcall;
    Function HandsOffStorage(iob : Longint) : HResult;Stdcall;
    Function SaveCompleted(iob : Longint;Const stg : IStorage) : HResult;Stdcall;
    Function InPlaceDeactivate : HResult;Stdcall;
    Function ContextSensitiveHelp(fEnterMode : BOOL) : HResult;Stdcall;
    Function GetClipboardData(Var chrg : TCharRange;reco : DWORD;
      Out dataobj : IDataObject) : HResult;Stdcall;
    Function ImportDataObject(dataobj : IDataObject;cf : TClipFormat;
      hMetaPict : HGLOBAL) : HResult;Stdcall;
  End;

  //IRichEditOleCallback----------------------------------------------------------
  //Interface utilise par RichEdit pour enrichir ses capacits.
  IRichEditOleCallback = Interface(IUnknown)
    ['{00020d03-0000-0000-c000-000000000046}']
    Function GetNewStorage(Out stg : IStorage) : HResult;Stdcall;
    Function GetInPlaceContext(Out Frame : IOleInPlaceFrame;
      Out Doc : IOleInPlaceUIWindow;
      lpFrameInfo : POleInPlaceFrameInfo) : HResult;Stdcall;
    Function ShowContainerUI(fShow : BOOL) : HResult;Stdcall;
    Function QueryInsertObject(Const clsid : TCLSID;Const stg : IStorage;
      cp : Longint) : HResult;Stdcall;
    Function DeleteObject(Const oleobj : IOleObject) : HResult;Stdcall;
    Function QueryAcceptData(Const dataobj : IDataObject;
      Var cfFormat : TClipFormat;reco : DWORD;fReally : BOOL;
      hMetaPict : HGLOBAL) : HResult;Stdcall;
    Function ContextSensitiveHelp(fEnterMode : BOOL) : HResult;Stdcall;
    Function GetClipboardData(Const chrg : TCharRange;reco : DWORD;
      Out dataobj : IDataObject) : HResult;Stdcall;
    Function GetDragDropEffect(fDrag : BOOL;grfKeyState : DWORD;
      Var dwEffect : DWORD) : HResult;Stdcall;
    Function GetContextMenu(seltype : Word;Const oleobj : IOleObject;
      Const chrg : TCharRange;Out Menu : HMENU) : HResult;Stdcall;
  End;

Implementation

End.
